local AddonName, a = ...
if a.BuildFail(50000) then return end
local L = a.Localize
local s = SpellFlashAddon
local x = s.UpdatedVariables
local _

-- Implement a dummy TTD function if we do not get one from another module
if type(s.TimeToDie) ~= 'function'  then
	a.print(L["No TimeToDie function found, using a dummy function. Consider installing Pusikas' Spellflash: TTD."])
	s.TimeToDie = function(unit)
		return 10
	end
end

local regenRate
a.energyRegeneration = function()
	_, regenRate = GetPowerRegen()
	regenRate = format("%.2f", regenRate)
	if s.Buff(115288--[[Energizing Brew]], "player") then
		regenRate = regenRate + 10
	end
	return regenRate
end

local HasteCDs = {
	80353--[[Time Warp]],
	2825--[[Bloodlust]],
	32182--[[Heroism]],
	90355--[[Ancient Hysteria]],
	49016--[[Unholy Frenzy]],
	26297--[[Berserking]],
}
a.Hasted = function()
	return s.Buff(HasteCDs, "player")
end

-- Detect raid-wide haste buffs, so we know when to
-- use potions
local BloodlustSpells = {
	80353--[[Time Warp]],
	2825--[[Bloodlust]],
	32182--[[Heroism]],
	90355--[[Ancient Hysteria]],
}
a.Bloodlust = function()
	return s.Buff(BloodlustSpells, "player")
end

a.MySelf = UnitGUID("player")

local LastAoETimestamp = 0
local CurrentTimestamp = 0
local LastAoETargetsHit = 0
local event, sourceGUID, destGUID, spellId
local DamagingAoESpells = {
	[101545--[[Flying Serpent Kick]]] = true,
	[107270--[[Spinning Crane Kick]]] = true,
	[113656--[[Fists of Fury]]] = true,
	[115181--[[Breath of Fire]]] = true,
	[116847--[[Rushing Jade Wind]]] = true,
	[121253--[[Keg Smash]]] = true,
}
a.COMBAT_LOG_EVENT_UNFILTERED = function (event, ...)
	CurrentTimestamp, event, _, sourceGUID, _, _, _, destGUID, _, _, _, spellId = ...
	if sourceGUID == a.MySelf and destGUID ~= a.MySelf and (((event == "SPELL_DAMAGE" or event == "SPELL_MISSED") and DamagingAoESpells[spellId]) or ((event == "SPELL_AURA_APPLIED" or event == "SPELL_AURA_REFRESH") and spellId == 130320--[[Rising Sun Kick]])) then
		if CurrentTimestamp == LastAoETimestamp then
			LastAoETargetsHit = LastAoETargetsHit + 1
		else
			LastAoETargetsHit = 1
			LastAoETimestamp = CurrentTimestamp
		end
	end
end
s.RegisterModuleEvent(AddonName, "COMBAT_LOG_EVENT_UNFILTERED", a.COMBAT_LOG_EVENT_UNFILTERED)

-- Check if we are in AoE mode
a.AoE = function()
	if CurrentTimestamp < LastAoETimestamp + 3 then
		if x.Spec == 1 then
			return LastAoETargetsHit > 2
		else
			return LastAoETargetsHit > 4
		end
	else
		return false
	end
end

-- Scan for Rune of Re-Origination
x.RoRO = false
local RuneIDs = {
	Trinket0Slot = {96918, 94532, 96546, 96174, 95802}, --[[Trinket 1]]
	Trinket1Slot = {96918, 94532, 96546, 96174, 95802}, --[[Trinket 1]]
}
a.scanForRoRO = function()
	local count = 0
	for slot, list in pairs(RuneIDs) do
		if s.Equipped(list, slot) then
			count = count + 1
		end
	end
	if count >= 1 then
		print("Found Rune of Re-Origination")
		x.RoRO = true
	else
		print("No Rune of Re-Origination found")
		x.RoRO = false
	end
end

s.RegisterModuleEvent(AddonName, "PLAYER_EQUIPMENT_CHANGED", a.scanForRoRO)
s.RegisterModuleEvent(AddonName, "ADDON_LOADED", a.scanForRoRO)